;------- TASM ASM mnemonics. -------
; Compile this file using:
; Set TASMOPTS = -b
; tasm -80 ThisCode.tas MyBinary.BIN
;-----------------------------------
; Zx81 Program name: VB81 XuR [Zxlogo.bas] :
; REM   line   name: 0 REM:   328 Bytes@4082-41C9

#define ORG  .org       ; TASM cross-assembler definitions
#define equ  .equ
;-----------------------------------

;------- Rom and Ram Symbols -------
RAM_T_ADDR equ $4030
PLOT_UNP equ $0BAF


ORG $4082 ; [@16514/@h4082]
Lb4082:
	NOP 
Lb4083:
	NOP 
Lb4084:
	NOP 
Lb4085:
	LD L,E 
Lb4086:
	NOP 
	CALL Lb4140 ; [16704]
	LD BC,$4084 
	LD (BC),A 
Lb408E:
	LD HL, Lb4082 
	LD B,(HL) 
	LD HL, Lb4083 
	LD C,(HL) 
	LD A,(Lb4085) 
	LD (RAM_T_ADDR),A ; SET T-ADDR
	CALL PLOT_UNP+3 ; []*BIOS ROM*
	LD A,(Lb4084) 
	LD HL, Lb4082 
	LD B,(HL) 
	LD HL, Lb4083 
	LD C,(HL) 
	CP $00 ; [0]
	CALL Z, Lb40E4 ; [16612]
	CP $01 ; [1]
	CALL Z, Lb40EC ; [16620]
	CP $02 ; [2]
	CALL Z, Lb40FB ; [16635]
	CP $03 ; [3]
	CALL Z, Lb4103 ; [16643]
	CP $04 ; [4]
	CALL Z, Lb4112 ; [16658]
	CP $05 ; [5]
	CALL Z, Lb4122 ; [16674]
	CP $06 ; [6]
	CALL Z, Lb411A ; [16666]
	CP $07 ; [7]
	CALL Z, Lb4131 ; [16689]
	LD HL, Lb4082 
	LD (HL),B 
	LD HL, Lb4083 
	LD (HL),C 
	LD HL, Lb4086 
	LD E,(HL) 
	DEC E 
	LD (HL),E 
	JP NZ, Lb408E ; [16526]
	RET ; ==========================

Lb40E4:
	LD H,A 
	LD A,C 
	CP $3F ; [63-"Z"]
	LD A,H 
	RET Z 
	INC C 
	RET ; ==========================

Lb40EC:
	LD H,A 
	LD A,C 
	CP $3F ; [63-"Z"]
	LD A,H 
	RET Z 
	LD H,A 
	LD A,B 
	CP $2B ; [43-"F"]
	LD A,H 
	RET Z 
	INC C 
	INC B 
	RET ; ==========================

Lb40FB:
	LD H,A 
	LD A,B 
	CP $2B ; [43-"F"]
	LD A,H 
	RET Z 
	INC B 
	RET ; ==========================

Lb4103:
	LD H,A 
	LD A,B 
	CP $2B ; [43-"F"]
	LD A,H 
	RET Z 
	LD H,A 
	LD A,C 
	CP $00 ; [0]
	LD A,H 
	RET Z 
	INC B 
	DEC C 
	RET ; ==========================

Lb4112:
	LD H,A 
	LD A,C 
	CP $00 ; [0]
	LD A,H 
	RET Z 
	DEC C 
	RET ; ==========================

Lb411A:
	LD H,A 
	LD A,B 
	CP $00 ; [0]
	LD A,H 
	RET Z 
	DEC B 
	RET ; ==========================

Lb4122:
	LD H,A 
	LD A,B 
	CP $00 ; [0]
	LD A,H 
	RET Z 
	LD H,A 
	LD A,C 
	CP $00 ; [0]
	LD A,H 
	RET Z 
	DEC B 
	DEC C 
	RET ; ==========================

Lb4131:
	LD H,A 
	LD A,B 
	CP $00 ; [0]
	LD A,H 
	RET Z 
	LD H,A 
	LD A,C 
	CP $3F ; [63-"Z"]
	LD A,H 
	RET Z 
	DEC B 
	INC C 
	RET ; ==========================

Lb4140:
	LD A,(Lb4084) 
	SLA A 
	SLA A 
	SLA A 
	SLA A 
	SLA A 
	SRL A 
	SRL A 
	SRL A 
	SRL A 
	SRL A 
	LD HL, Lb4084 
	LD (HL),A 
	RET ; ==========================

	LD A,$00 
	LD HL, Lb4082 
	LD (HL),A 
	LD HL, Lb4083 
	LD (HL),A 
	LD HL, Lb4084 
	LD (HL),A 
	RET ; ==========================

	LD HL,$42ED 
	INC (HL) 
	NOP 
	NOP 
	RET ; ==========================

	LD HL,$4214 
	DEC (HL) 
	NOP 
	NOP 
	RET ; ==========================

	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	LD HL, Lb4085 
	LD A,$6B 
	LD (HL),A 
	RET ; ==========================

	LD HL, Lb4085 
	LD A,$9F 
	LD (HL),A 
	RET ; ==========================

	LD B,$01 
	LD A,(Lb4084) 
	ADD A,B 
	LD HL, Lb4084 
	LD (HL),A 
	CALL Lb4140 ; [16704]
	RET ; ==========================

	LD B,$04 
	LD A,(Lb4084) 
	SUB B 
	LD HL, Lb4084 
	LD (HL),A 
	CALL Lb4140 ; [16704]
	RET ; ==========================

	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	LD A,$14 
	LD HL, Lb4083 
	LD (HL),A 
	LD A,$00 
	LD HL, Lb4082 
	LD (HL),A 
	RET ; ==========================

	ADD A,B 
	DEC A 



.end
